*                                    AVERTISSEMENT

* Le gouvernement du Canada (Statistique Canada) possde tous les droits de proprit
* intellectuelle (y compris le droit d'auteur) relatifs  ce logiciel.  Sous rserve
* des modalits dcrites ci-dessous, vous obtenez une licence non exclusive et non
* transmissible d'utilisation de ce logiciel.
*
* Ce logiciel vous est fourni  tel quel , et le titulaire ne donne aucune garantie
* expresse ou implicite, ce qui comprend les garanties de qualit marchande et de
* convenance  une fin particulire mais ne se limite pas  ces garanties.  En aucune
* circonstance le titulaire ne sera responsable de dommages indirects, particuliers ou
* conscutifs, ou d'autres dommages semblables.  Ce contrat sera automatiquement rsili,
* sans pravis, si vous omettez de respecter une quelconque des modalits du contrat.;

/*******************************************************************/
/* Date: 1er dcembre 1997                                         */
/* Modifi: 21 avril 2000                                          */
/* Modifi: 28 novembre 2004 (pour l'ESG cycle 17)                 */
/*******************************************************************/

/*********************************************************************************/
/***                                                                           ***/
/***                        Programme SAS BOOTVAR                              ***/
/***                                                                           ***/
/*** Ce programme calcule des estimations de variance pour diffrents types    ***/
/*** d'estimations  l'aide des poids bootstrap.   l'aide de macros SAS,      ***/
/*** ce programme peut calculer des estimations de variance pour des totaux,   ***/
/*** des rapports, et des diffrences de rapports.  Il peut aussi calculer des ***/
/*** estimations de variance pour des paramtres de rgressions linaires ou   ***/
/*** logistiques.  Ce programme peut aussi                                     ***/
/*** tre modifi pour s'adapter  d'autres types d'analyse.                   ***/
/***                                                                           ***/
/*** Ce programme est divis en 4 sections, dcrites plus bas.  Tout au long   ***/
/*** du programme, les changements que l'utilisateur doit apporter sont indi-  ***/
/*** qus.                                                                     ***/
/***                                                                           ***/
/*** Section 1: Dclaration des variables macros                               ***/
/***            C'est  cet endroit qu'on dfinit les variables qui seront     ***/
/***            utilises tout au long du programme.  Certains changements     ***/
/***            doivent tre apports par l'utilisateur.                       ***/
/*** Section 2: Dclaration des macros                                         ***/
/***            C'est  cet endroit qu'est dfinie la portion du programme qui ***/
/***            calcule les estimations de variance.  Aucun changement n'est   ***/
/***            requis de la part de l'utilisateur dans cette section.         ***/
/*** Section 3: Programme principal                                            ***/
/***            C'est  cet endroit qu'on lit les fichiers contenant les       ***/
/***            variables  analyser et les poids bootstrap.  Les variables    ***/
/***             utiliser dans les analyses doivent tre dfinies par l'utili-***/
/***            sateur avant d'utiliser ce programme.                          ***/
/*** Section 4: noncs pour soumettre les macros                              ***/
/***            C'est  cet endroit que l'utilisateur doit indiqu quelle(s)   ***/
/***            macro(s) il/elle dsire soumettre.   ce stade, l'utilisateur  ***/
/***            peut soumettre une macro une fois, une macro plusieurs fois,   ***/
/***            ou plusieurs macros.  tant donn le grand nombre d'observa-   ***/
/***            tions  analyser, il est recommand de limiter le              ***/
/***            nombre de macros qui sont soumises, en particulier dans le cas ***/
/***            de rgressions.                                                ***/
/***                                                                           ***/
/*** Avant d'utiliser ce programme, l'utilisateur doit prparer un fichier     ***/
/*** d'analyse qui contiendra les variables  analyser.  Ce fichier ne devrait ***/
/*** contenir que les enregistrements pour lesquels l'analyse est ncessaire   ***/
/*** (p.e. si l'analyse est faite pour le groupe d'ge 25 ans et plus, seuls   ***/
/*** les enregistrements des individus de 25 ans et plus devraient tre inclus ***/
/*** dans le fichier).  Une variable appele REGIONC doit aussi tre cre si  ***/
/*** les analyses sont faites  un niveau rgional.  Par exemple, si l'analyse ***/
/*** est faite au niveau provincial, la variable REGIONC prendra la mme valeur***/
/*** que la variable qui contient la province sur le fichier de microdonnes   ***/
/*** (p.e. PRV).       Si l'analyse est faite au niveau des rgions de sant,  ***/
/*** la variable REGIONC prendra la valeur de la rgion de sant pour chaque   ***/
/*** enregistrement.                                                           ***/
/***                                                                           ***/
/*** N.B. Pour calculer un total, un rapport, ou une diffrence entre deux     ***/
/*** rapports, les estimations sont obtenues en sommant le poids des enregis-  ***/
/*** trements qui ont la caractristique d'intrt.  Donc, une variable indi-  ***/
/*** catrice doit tre cre pour chaque variable  analyser.  Elle prendra la ***/
/*** valeur 1 lorsque l'enregistrement a la caractristique d'intrt et 0     ***/
/*** sinon.                                                                    ***/
/*********************************************************************************/

options ps=60 ls=90 ;


/*********************************************************************************/
/*** Section 1: Dclaration des variables macros                               ***/
/*** %let R=25;	pour les poids bootstrap de l'ESG cycle 17                     ***/
/*********************************************************************************/

%let R=25;                         /* paramtre du bootstrap moyen (fixe) */


/*****************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOMBRE DE POIDS BOOTSTRAP  UTILISER,  ***/
/*** DIVIS PAR 100                                                        ***/
/*** %let B=2;	pour les poids bootstrap de l'ESG cycle 17                 ***/
/*****************************************************************************/

%let B=2;                     /* nombre de poids bootstrap Bx100 */


/************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE RPERTOIRE CONTENANT LE FICHIER   ***/
/*** D'ANALYSE (in1) ET LE FICHIER CONTENANT LES POIDS BOOTSTRAP      ***/
/*** (in2).  LES FICHIERS DE SORTIES SERONT SAUVEGARDS DANS LE       ***/
/*** RPERTOIRE SPCIFI POUR in3.                                    ***/
/************************************************************************/

libname in1 "c:\data";
libname in2 "c:\bootstrp";
libname in3 "c:\output";


/*********************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOM DU FICHIER SAS CONTENANT LES VARIABLES ***/
/*** D'ANALYSE.                                                                ***/
/*** %let Mfile=xxx;                                                           ***/
/*********************************************************************************/

%let Mfile=in1.xxx;                          /* Nom du fichier SAS principal */


/*********************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOM DU FICHIER SAS CONTENANT LES POIDS     ***/
/*** BOOTSTRAP. SI LE FICHIER SAS N'EXISTE PAS, IL DOIT TRE CRE.             ***/
/*********************************************************************************/

data in2.boot_gss;
  %let datafid='c:\data\C17PUMFM.DAT';
  %include 'c:\data\C17PUMFM_INPUT.sas';
  rename wtbs_001-wtbs_200=bsw1-bsw200 wght_per=fwgt; /* renomm selon les noms standard */ 
  keep recid wght_per wtbs_001-wtbs_200;
run;

%let bsamp=in2.boot_gss;               /* fichier SAS des poids bootstrap */


/*****************************************************************/
/*** L'UTILISATEUR DOIT SPCIFIER LA VALEUR DES PARAMTRES by, ***/
/*** wo ET kp.  CEUX-CI INDIQUENT SI L'ANALYSE EST FAITE AU    ***/
/*** NIVEAU RGIONAL OU POUR L'ENSEMBLE DU FICHIER.            ***/
/***                                                           ***/
/*** SI L'ANALYSE EST FAITE POUR L'ENSEMBLE DU FICHIER, ALORS  ***/
/***    %let by=*;                                             ***/
/***    %let wo=;                                              ***/
/***    %let kp=;                                              ***/
/***                                                           ***/
/*** SINON, SI L'ANALYSE EST FAITE AU NIVEAU RGIONAL, ALORS   ***/
/***    %let by=;                                              ***/
/***    %let wo=*;                                             ***/
/***    %let kp=regionc;                                        ***/
/*****************************************************************/

%let by=;
%let wo=*;
%let kp=regionc;


data time;
  format start datetime16.;
  start=datetime();
  output;
run;


/*********************************************************************************/
/*** Section 2: Dclaration des macros                                         ***/
/*********************************************************************************/

%let printtot=0;
%let printdif=0;
%let printreg=0;
%let printlog=0;

%global dep;

*************************************;

%macro total(infile,var,bssz=,multi=);

*************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var;
&by  by regionc;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

data est;
  set ytot;
  length var1 $ 8;
  length var2 $ 8;
  length type $ 8;
  bs_var=&multi*((&bssz-1)*(var(of ybs1-ybs&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=round((bs_sd/yhat)*100,.01);
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var";
  var2="None";
  type="Total";
  drop ybs1-ybs&bssz _type_ _freq_;
run;

proc append data=est base=alltots;
run;

%let printtot=1;

%mend total;


*******************************************;

%macro ratio(infile,var1,var2,bssz=,multi=);

*******************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var1;
&by  by regionc;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var2;
&by  by regionc;
  output out=xtot
         sum=xhat xbs1-xbs&bssz;
run;

data est;
  merge ytot xtot;
  array ybs{&bssz};
  array xbs{&bssz};
  array rbs{&bssz};
  length var1 $ 8;
  length var2 $ 8;
  length type $ 8;
  yhat=((yhat/xhat)*100);
  do i=1 to &bssz;
    rbs{i}=((ybs{i}/xbs{i})*100);
  end;
  bs_var=&multi*((&bssz-1)*(var(of rbs1-rbs&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=round((bs_sd/yhat)*100,.01);
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var1";
  var2="&var2";
  type="Ratio";
  drop ybs1-ybs&bssz xbs1-xbs&bssz rbs1-rbs&bssz xhat i _type_ _freq_;
run;

proc append data=est base=alltots;
run;

%let printtot=1;

%mend ratio;


********************************************************;

%macro diff_rat(infile,var1,var2,var3,var4,bssz=,multi=);

********************************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var1;
&by  by regionc;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var2;
&by  by regionc;
  output out=xtot
         sum=xhat xbs1-xbs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var3;
&by  by regionc;
  output out=yytot
         sum=yyhat yybs1-yybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var4;
&by  by regionc;
  output out=xxtot
         sum=xxhat xxbs1-xxbs&bssz;
run;

data est;
  merge ytot xtot yytot xxtot;
  array ybs{&bssz};
  array xbs{&bssz};
  array yybs{&bssz};
  array xxbs{&bssz};
  array drbs{&bssz};
  length var1 $ 8;
  length var2 $ 8;
  length var3 $ 8;
  length var4 $ 8;
  length type $ 10;
  yhat=(((yhat/xhat)-(yyhat/xxhat))*100);
  do i=1 to &bssz;
    drbs{i}=(((ybs{i}/xbs{i})-(yybs{i}/xxbs{i}))*100);
  end;
  bs_var=(&multi*((&bssz-1)*(var(of drbs1-drbs&bssz)))/&bssz);
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/yhat)*100,.01));
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var1";
  var2="&var2";
  var3="&var3";
  var4="&var4";
  type="Diff_Ratio";
  drop ybs1-ybs&bssz xbs1-xbs&bssz yybs1-yybs&bssz xxbs1-xxbs&bssz drbs1-drbs&bssz
       xhat xxhat yyhat i _type_ _freq_;
run;

proc append data=est base=diffrat;
run;

%let printdif=1;

%mend diff_rat;


*********************************************;

%macro regress(infile,yvar,xvar,bssz=,multi=);

*********************************************;

proc reg data=&infile outest=orig(keep=&kp intercept &xvar) noprint;
  model &yvar=&xvar;
  weight fwgt;
&by  by regionc;
run;

proc transpose data=orig out=origest(drop=_label_) prefix=bhat name=beta;
  var intercept &xvar;
&by  by regionc;
run;

%let L=%eval(&bssz/10);

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

  data poids;
    set &infile;
    keep bsw&j-bsw&kL &yvar &xvar &kp;
  run;

  %do i=&j %to &kL;

   proc reg data=poids outest=betas(keep=&kp intercept &xvar) noprint;
     model &yvar=&xvar;
     weight bsw&i;
&by  by regionc;
   run;

   proc transpose data=betas out=betat prefix=best name=beta;
     var intercept &xvar;
&by  by regionc;
   run;

   data betat;
     set betat;
     drop _label_;
     rename best1=best&i;
   run;

   %if (&i =1) %then %do;

     data bsbeta;
       set betat;
     run;

   %end;
   %else %do;

     data bsbeta;
       merge bsbeta betat;
&by    by regionc;
     run;

   %end;
  %end;
%end;

data est;
  merge origest bsbeta;
  rename bhat1=bhat;
  bs_var=&multi*((&bssz-1)*(var(of best1-best&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/bhat1)*100,.01));
  cil95=bhat1-1.96*bs_sd;
  ciu95=bhat1+1.96*bs_sd;
  ydep="&yvar";
  drop best1-best&bssz;
run;

proc append data=est base=bs_reg;
run;

%let printreg=1;
%let dep=&yvar;

%mend regress;


*********************************************;

%macro logreg(infile,yvar,xvar,bssz=,multi=);

*********************************************;
proc logistic data=&infile outest=orig(keep=&kp intercept &xvar) descending noprint;
  model &yvar=&xvar;
  &by by regionc;
  weight fwgt;
run;

proc transpose data=orig out=origest prefix=bhat name=beta;
  var intercept &xvar;
  &by by regionc;
run;

%let L=%eval(&bssz/10);

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

  data poids;
    set &infile;
    keep bsw&j-bsw&kL &yvar &xvar &kp;
  run;

  %do i=&j %to &kL;

    proc logistic data=poids outest=betas(keep=&kp intercept &xvar) noprint descending;
      model &yvar=&xvar;
      &by by regionc;
      weight bsw&i;
    run;

    proc transpose data=betas out=betat prefix=best name=beta;
      var intercept &xvar;
      &by by regionc;
    run;

    data betat;
      set betat;
      rename best1=best&i;
    run;

    %if (&i =1) %then %do;

      data bsbeta;
        set betat;
      run;

    %end;
    %else %do;

      data bsbeta;
        merge bsbeta betat;
        &by by regionc;
      run;

    %end;
  %end;
%end;

data est;
  merge origest bsbeta;
  rename bhat1=bhat;
  bs_var=&multi*((&bssz-1)*(var(of best1-best&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/bhat1)*100,.01));
  wald=(bhat1/bs_sd)*(bhat1/bs_sd);
  pvalue=1-probchi(wald,1);
  lo95=bhat1-1.96*bs_sd;
  hi95=bhat1+1.96*bs_sd;
  odds=exp(bhat1);
  cil95=exp(lo95);
  ciu95=exp(hi95);
  ydep="&yvar";
  drop best1-best&bssz;
run;

proc append data=est base=bs_reglg;
run;

%let printlog=1;
%let dep=&yvar;

%mend logreg;


****************;

%macro prnttot;

****************;
%if &printtot=1 %then %do;

&by   proc sort data=alltots;
&by     by regionc;
&by   run;


/**************************************************/
/* Imprime les rsultats des macro total et ratio */
/**************************************************/

   proc print data=alltots;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Totaux et des Rapports";
     var &kp type var1 var2 yhat bs_sd bs_cv cil95 ciu95;
     format yhat bs_sd cil95 ciu95 11.2;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Total ou Rapport)***/
        /*** var1 et var2 : variables utilises pour calculer   ***/
        /***                les estimations.  Pour un total,    ***/
        /***                var2=Aucune.                        ***/
        /*** yhat         : estimation du paramtre (en % pour  ***/
        /***                un rapport)                         ***/
        /*** bs_sd        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** cil95        : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /*** ciu95        : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prnttot;

****************;

%macro prntdiff;

****************;
%if &printdif=1 %then %do;

&by   proc sort data=diffrat;
&by     by region;
&by   run;

/**********************************************/
/* Imprime les rsultats de la macro diff_rat */
/**********************************************/

   proc print data=diffrat;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Diffrences entre des Rapports";
     var &kp type var1 var2 var3 var4 yhat bs_sd bs_cv cil95 ciu95;
     format yhat bs_sd cil95 ciu95 11.2;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Diff_Rapport)    ***/
        /*** var1,var2,                                         ***/
        /*** var3 et var4 : variables utilises pour calculer   ***/
        /***                l'estimation                        ***/
        /*** yhat         : estimation (diffrence en %)        ***/
        /*** bs_sd        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** cil95        : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /*** ciu95        : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/



%mend prntdiff;

****************;

%macro prntreg;

****************;
%if &printreg=1 %then %do;

/******************************************************/
/* Imprime les rsultats de la macro regress          */
/******************************************************/

   proc print data=bs_reg;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour une";
     title2 "Rgression";
     title3 "Variable dpendante: &dep";
     var &kp beta bhat bs_var bs_sd bs_cv cil95 ciu95;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   beta       : paramtre  estimer                 ***/
        /***   bhat       : estimation du paramtre             ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_sd      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de l'esti- ***/
        /***                mation du paramtre                 ***/
        /***   cil95      : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /***   ciu95      : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prntreg;

****************;

%macro prntlog;

****************;
%if &printlog=1 %then %do;

/********************************************/
/* Imprime les rsultats de la macro logreg */
/********************************************/

   proc print data=bs_reglg;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Rgressions logistiques";
     title3 "Variable dpendante: &dep";
     var &kp beta bhat odds wald pvalue bs_var bs_sd bs_cv cil95 ciu95;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   beta       : paramtre  estimer                 ***/
        /***   bhat       : estimation du paramtre             ***/
        /***   odds       : rapport de cotes                    ***/
        /***   wald       : statistique de Wald                 ***/
        /***   pvalue     : valeur p de la statistique de Wald  ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_sd      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de         ***/
        /***                l'estimation du paramtre           ***/
        /***   cil95      : borne infrieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /***   ciu95      : borne suprieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /**********************************************************/


%mend prntlog;


*********************************************************************;
*  Section 3: Programme principal                                   *;
*********************************************************************;

/* Lit le fichier principal */

/************************************************************************/
/***  CAUSE DU GRAND NOMBRE D'OBSERVATIONS, SEULES LES VARIABLES     ***/
/*** REQUISES POUR FAIRE LES ANALYSES ET LA VARIABLES                 ***/
/*** "RECID" DEVRAIT TRE CONSERVE DSORMAIS.                        ***/
/************************************************************************/

   data gss (index=(recid));
     set &Mfile (keep= recid + VARIABLES  ANALYSER);
   run;

/* Lit les poids bootstrap */
/* FWGT correspond  WGHT_PER */

   data bsamp (index=(recid));
     set &bsamp;
     keep fwgt recid bsw1-bsw&B.00;
   run;


/* Apparie le fichier principal et les poids bootstrap */

    data bs_gss;
      merge gss (in=in1) bsamp (in=in2);
      by recid;
      if in1;
    run;

&by  proc sort data=bs_gss;
&by     by regionc;
&by  run;

   proc datasets library=work;
     delete gss bsamp;
   run;


/*********************************************************************************/
/*** Section 4: noncs pour soumettre les macros                              ***/
/*********************************************************************************/

/**********************************************************************************/
/*** Les estimations de variance sont calcules  l'aide des macros SAS dfinies***/
/*** plus tt dans le programme.  Ces macros SAS peuvent tre soumises durant   ***/
/*** l'excution du programme, selon les besoins de l'utilisateur.  Pour        ***/
/*** soumettre une macro, il suffit de spcifier un nonc indiquant le nom de  ***/
/*** la macro  soumettre et les paramtres  utiliser.  Dans ce programme, les ***/
/*** paramtres indiquent quel fichier doit tre lu, quelles variables seront   ***/
/*** utilises, combien de poids bootstrap seront utiliss, et combien          ***/
/*** d'chantillons de bootstrap ont t choisis.  Le nom du fichier  lire est ***/
/*** toujours le mme (BS_GSS) et les deux derniers paramtres ont dj t    ***/
/*** dfinis au dbut du programme.  L'utilisateur n'a donc qu' spcifier les  ***/
/*** variables  analyser.                                                      ***/
/***                                                                            ***/
/*** Chaque soumission d'une macro donnera une estimation de la variance d'un   ***/
/*** seul paramtre  estimer.  Si plus d'un paramtre et sa variance doivent   ***/
/*** tre calculs, il faut alors soumettre la macro  plusieurs reprises.      ***/
/***                                                                            ***/
/*** Un exemple d'un nonc pour soumettre une macro apparat dans le programme ***/
/***  l'endroit o l'utilisateur doit spcifier cet nonc.  L'exemple est mis ***/
/*** en commentaire dans le programme.  L'nonc utilis par l'utilisateur sera ***/
/*** identique  l'exemple,  l'exception des variables  analyser.             ***/
/**********************************************************************************/

/*********/
/*       */
/* Total */
/*       */
/*********/

   proc datasets library=work; /* initialise alltots */
     delete alltots;
   run;

/****************************************************************************/
/*** Pour soumettre la macro total, l'nonc suivant est utilis:         ***/
/*** %total(infile,var,bssz=,multi=);                                     ***/
/***       o    infile : bs_gss                                         ***/
/***             var    : la variable pour laquelle un total doit tre    ***/
/***                      calcul                                         ***/
/***             bssz=  : bssz=&B.00                                      ***/
/***             multi= : multi=&R                                        ***/
/***                                                                      ***/
/****************************************************************************/

 *  %total(bs_gss,VAR,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro total */

   proc datasets library=work;
     delete ytot est;
   run;


/***********/
/*         */
/* Rapport */
/*         */
/***********/

/******************************************************************************/
/*** Pour soumettre la macro ratio, l'nonc suivant est utilis:           ***/
/*** %ratio(infile,var1,var2,bssz=,multi=);                                 ***/
/***       o    infile : bs_gss                                           ***/
/***             var1   : la variable au numrateur du rapport              ***/
/***             var2   : la variable au dnominateur du rapport            ***/
/***             bssz=  : bssz=&B.00                                        ***/
/***             multi= : multi=&R                                          ***/
/***                                                                        ***/
/******************************************************************************/


 *  %ratio(bs_gss,VAR1,VAR2,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro ratio */
   proc datasets library=work;
     delete ytot xtot est;
   run;

%prnttot;

/**********************************************************/
/*** Les rsultats des macro total et ratio             ***/
/*** peuvent tre sauvegards dans un fichier permanent ***/
/**********************************************************/

*   data in3.ZZZ;
*     set alltots;
*   run;


/*********************************/
/*                               */
/* Diffrence entre des Rapports */
/*                               */
/*********************************/

   proc datasets library=work; /* initialise diffrat */
     delete diffrat;
   run;

/******************************************************************************/
/*** Pour soumettre la macro diff_rat, l'nonc suivant est utilis:        ***/
/*** %diff_rat(infile,var1,var2,var3,var4,bssz=,multi=);                    ***/
/***       o    infile : bs_gss                                           ***/
/***             var1   : la variable au numrateur du 1er rapport          ***/
/***             var2   : la variable au dnominateur du 1er rapport        ***/
/***             var3   : la variable au numrateur du 2e rapport           ***/
/***             var4   : la variable au dnominateur du 2e rapport         ***/
/***             bssz=  : bssz=&B.00                                        ***/
/***             multi= : multi=&R                                          ***/
/***                                                                        ***/
/*** Nota: L'intervalle de confiance est calcul pour une analyse faisant   ***/
/*** une seule comparaison de rapports.  Si des comparaisons multiples sont ***/
/*** faites, la faon de calculer l'intervalle de confiance doit tenir      ***/
/*** compte de cette situation.  Pour cette raison, dans le cas de comparai-***/
/*** sons multiples, la valeur de la loi normale (Z) utilise dans le       ***/
/*** calcul de l'intervalle de confiance doit tre corrige  la section 2, ***/
/*** Dclaration des macros, en utilisant, par exemple, l'approche de       ***/
/*** Bonferroni pour les comparaisons multiples.                            ***/
/***                                                                        ***/
/******************************************************************************/


 *  %diff_rat(bs_gss,VAR1,VAR2,VAR3,VAR4,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro diff_rat */
   proc datasets library=work;
     delete ytot xtot yytot xxtot est;
   run;

%prntdiff;

/**************************************************/
/*** Les rsultats de la macro diff_rat peuvent ***/
/*** tre sauvegards dans un fichier permanent ***/
/**************************************************/

*   data in3.ZZZ;
*     set diffrat;
*   run;


/**************/
/*            */
/* Rgression */
/*            */
/**************/

   proc datasets library=work; /* initialise bs_reg */
     delete bs_reg;
   run;

/*******************************************************************************/
/*** Pour soumettre la macro regress, l'nonc suivant est utilis:          ***/
/*** %regress(infile,yvar,xvar,bssz=,multi=);                                ***/
/***       o    infile : bs_gss                                            ***/
/***             yvar   : la variable dpendante                             ***/
/***             xvar   : les variables indpendantes.  Les variables doivent***/
/***                      tre inscrites comme elles le seraient dans l'non-***/
/***                      c d'un modle (sans virgules entre elles).        ***/
/***             bssz=  : bssz=&B.00                                         ***/
/***             multi= : multi=&R                                           ***/
/***                                                                         ***/
/*******************************************************************************/


 *  %regress(bs_gss,YVAR,XVAR,bssz=&B.00,multi=&R);
    %regress(bs_gss,edu,urban females,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro regress */
   proc datasets library=work;
     delete betas betat bsbeta origest;
   run;


/*************************/
/*                       */
/* Rgression Logistique */
/*                       */
/*************************/

   proc datasets library=work; /* initialise bs_reglg */
     delete bs_reglg;
   run;

/*******************************************************************************/
/*** Pour soumettre la macro logreg, l'nonc suivant est utilis:           ***/
/*** %logreg(infile,yvar,xvar,bssz=,multi=);                                 ***/
/***       o    infile : bs_gss                                            ***/
/***             yvar   : la variable dpendante                             ***/
/***             xvar   : les variables indpendantes.  Les variables doivent***/
/***                      tre inscrites comme elles le seraient dans l'non-***/
/***                      c d'un modle (sans virgules entre elles).        ***/
/***             bssz=  : bssz=&B.00                                         ***/
/***             multi= : multi=&R                                           ***/
/***                                                                         ***/
/*******************************************************************************/


 *  %logreg(bs_gss,YVAR,XVAR,bssz=&B.00,multi=&R);
    %logreg(bs_gss,edu,urban females,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro logreg */
   proc datasets library=work;
     delete betas betat bsbeta origest;
   run;


%prntreg;

/**********************************************************/
/*** Les rsultats des macros regress et regglm         ***/
/*** peuvent tre sauvegards dans un fichier permanent ***/
/**********************************************************/

*   data in3.ZZZ;
*     set bs_reg;
*   run;


%prntlog;

/**************************************************/
/*** Les rsultats de la macro logreg peuvent   ***/
/*** tre sauvegards dans un fichier permanent ***/
/**************************************************/

*   data in3.ZZZ;
*     set bs_reglg;
*   run;


data time;
  set time;
  format stop datetime16.;
  stop=datetime();
  output;
run;

proc print data=time;
  title 'Temps requis pour excuter le programme';
run;

/* Fin du programme SAS Bootvar */
