/****************************************************************************/
/*                                                                          */
/*         USE THE GSS cycle 17 PUMF                                        */
/*         TO STUDY THE RELATION BETWEEN EDUCATION LEVEL                    */
/*         AND THE URBAN/RURAL INDICATOR                                    */
/*                                                                          */
/****************************************************************************/

libname in1 'c:\data';

data in1.ex1b;
%let datafid='c:\data\C17PUMFM.DAT';
%include 'c:\data\C17PUMFM_INPUT.sas';
keep regionc edu5 edu sex females luc_rst urban
     wght_per total recid;

if prv=11 then delete; /* luc_rst=3 in PEI */

regionc=prv; 

total=1;

if edu5 in(4,5) then edu=1;
else if edu5 in(1,2,3) then edu=0;
else edu=.;

if edu=. then delete;

/* Dummy variables */

  females=0;
  if sex=2 then females=1;

  urban=0;
  if luc_rst>3 then urban=.; /* Missing values */
  if luc_rst=1 then urban=1;

run;

proc sort; by regionc;

proc logistic data=in1.ex1b descending;
     model edu = urban females;
     weight wght_per;
	 by regionc;
title 'EDUCATION VERSUS URBAN/RURAL';
run;
